package com.progressbardemo;



import android.app.Activity;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

public class ProgressbarDemo extends Activity {
	
	private Button myProssButton = null;
	private Button myProssBarhandleButton = null;
	private Button myProssSynctaskButton = null;
	public ProgressDialog myDialog = null;
	private ProgressBar progressBarHandle;
	private TextView myProssBarhandleText;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        progressBarHandle=(ProgressBar) findViewById(R.id.myProssBarhandle); 
		myProssBarhandleText=(TextView) findViewById(R.id.myProssBarhandleText); 
		
		
		//ȶԻʾť
		myProssButton = (Button) findViewById(R.id.myProssButton); 
		myProssButton.setOnClickListener(new ProssButtonListener());
		
		
		//handleť
		myProssBarhandleButton = (Button) findViewById(R.id.myProssBarhandleButton); 
		myProssBarhandleButton.setOnClickListener(new ProssBarHandleButtonListener());
		
		//synctaskť
		myProssSynctaskButton = (Button) findViewById(R.id.myProssSynctaskButton); 
		myProssSynctaskButton.setOnClickListener(new ProssBarSyncButtonListener());
    }
    
 

	//ȶԻť
	class ProssButtonListener implements OnClickListener {
		@Override
		public void onClick(View v) {
			myDialog = ProgressDialog.show(ProgressbarDemo.this, "",
					"", true);

			new Thread() {
				public void run() {
					try {
						/* дҪеĳƬ */
						/* ΪԿЧͣ3Ϊʾ */
						sleep(3000);
					} catch (Exception e) {
						e.printStackTrace();
					} finally {
						// жmyDialog
						myDialog.dismiss();
					}
				}
			}.start(); /* ʼ߳ */
		}
	}

	
	
	
	//handleť
	class ProssBarHandleButtonListener implements OnClickListener {
		@Override
		public void onClick(View v) {
			progressBarHandle.setVisibility(View.VISIBLE);
			myProssBarhandleText.setVisibility(View.VISIBLE);
			progressBarHandle.setMax(1000); 
			new Thread() { 
				public void run() {
					for(int i=0;i<=1000;){
					try {
						/* деĽ */
						Message msg = new Message();
						msg.what = 1;
						msg.getData().putInt("size", i);
						handler.sendMessage(msg);//Ϣ
						/* ΪԿЧͣ1Ϊʾ */
						sleep(100);
						i+=10;
					} catch (Exception e) {
						handler.obtainMessage(-1).sendToTarget();
						e.printStackTrace();
					}  
				}
				}
			}.start(); /* ʼ߳ */
		}
	}
	
	 private Handler handler = new Handler(){

			@Override
			public void handleMessage(Message msg) {			
				switch (msg.what) {
				case 1:				
					progressBarHandle.setProgress(msg.getData().getInt("size"));
					float num = (float)progressBarHandle.getProgress()/(float)progressBarHandle.getMax();
					int result = (int)(num*100);
					System.out.println("progressBarHandle.getProgress()======="+progressBarHandle.getProgress());
					myProssBarhandleText.setText(result+ "%");
					if(progressBarHandle.getProgress()==progressBarHandle.getMax()){
						Toast.makeText(ProgressbarDemo.this, "سɹ", 1).show();
						progressBarHandle.setVisibility(View.GONE);
						myProssBarhandleText.setVisibility(View.GONE);
					}
					break;

				case -1:
					Toast.makeText(ProgressbarDemo.this,"ʧ", 1).show();
					break;
				}
			}
	    };

	//synctaskť
	class ProssBarSyncButtonListener implements OnClickListener {
		@Override
		public void onClick(View v) {
			 
			 new AsyncLoader().execute((Void)null);  
		}
	}
	
	  
	 //AsyncTask 
	class AsyncLoader extends AsyncTask<Void, Integer, Integer> {
		@Override
//		 doInBackgroundִǰִ
		protected void onPreExecute(){
			progressBarHandle.setVisibility(View.VISIBLE); 
			myProssBarhandleText.setVisibility(View.VISIBLE);
			progressBarHandle.setMax(100000);
		}
		
		protected Integer doInBackground(Void... params) {
			int totalSize = 100000;
			for (int i = 0; i < 100000; ) { 
				publishProgress(i);  //ͨϢݸonProgressUpdateִ
				i+=10;
			}
			return totalSize;
		}
//		doInBackgroundִйִ
		protected void onProgressUpdate(Integer... progress) {
			progressBarHandle.setProgress(progress[0]);  
			float num = (float)progressBarHandle.getProgress()/(float)progressBarHandle.getMax();
			int result = (int)(num*100);
			 myProssBarhandleText.setText(result+ "%");
		}

//		doInBackgroundִ
		protected void onPostExecute(Integer result) {
			Toast.makeText(ProgressbarDemo.this, "سɹ"+result, 1).show(); 
			myProssBarhandleText.setVisibility(View.GONE);
			progressBarHandle.setVisibility(View.GONE);
		}
	} 
}